Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Samsung.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Samsung.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Samsung.pm	(revision 34921)
@@ -8,4 +8,10 @@
 # References:   1) Tae-Sun Park private communication
 #               2) http://www.cybercom.net/~dcoffin/dcraw/
+#               3) Pascal de Bruijn private communication (NX100)
+#               4) Jaroslav Stepanek via rt.cpan.org
+#               5) Nick Livchits private communication
+#               6) Sreerag Raghavan private communication (SM-C200)
+#               IB) Iliah Borg private communication (LibRaw)
+#               NJ) Niels Kristian Bech Jensen private communication
 #------------------------------------------------------------------------------
 
@@ -13,12 +19,39 @@
 
 use strict;
-use vars qw($VERSION);
+use vars qw($VERSION %samsungLensTypes);
 use Image::ExifTool qw(:DataAccess :Utils);
 use Image::ExifTool::Exif;
 
-$VERSION = '1.08';
+$VERSION = '1.48';
 
 sub WriteSTMN($$$);
 sub ProcessINFO($$$);
+sub ProcessSamsungMeta($$$);
+sub ProcessSamsungIFD($$$);
+
+# Samsung LensType lookup
+%samsungLensTypes = (
+    # (added "Samsung NX" in all of these lens names - ref 4)
+    0 => 'Built-in or Manual Lens', #PH (EX1, WB2000)
+    1 => 'Samsung NX 30mm F2 Pancake',
+    2 => 'Samsung NX 18-55mm F3.5-5.6 OIS', # (also version II, ref 1)
+    3 => 'Samsung NX 50-200mm F4-5.6 ED OIS',
+    # what about the non-OIS version of the 18-55,
+    # which was supposed to be available before the 20-50? - PH
+    4 => 'Samsung NX 20-50mm F3.5-5.6 ED', #PH/4
+    5 => 'Samsung NX 20mm F2.8 Pancake', #PH
+    6 => 'Samsung NX 18-200mm F3.5-6.3 ED OIS', #4
+    7 => 'Samsung NX 60mm F2.8 Macro ED OIS SSA', #1
+    8 => 'Samsung NX 16mm F2.4 Pancake', #1/4
+    9 => 'Samsung NX 85mm F1.4 ED SSA', #4
+    10 => 'Samsung NX 45mm F1.8', #3
+    11 => 'Samsung NX 45mm F1.8 2D/3D', #3
+    12 => 'Samsung NX 12-24mm F4-5.6 ED', #4
+    13 => 'Samsung NX 16-50mm F2-2.8 S ED OIS', #forum3833
+    14 => 'Samsung NX 10mm F3.5 Fisheye', #NJ
+    15 => 'Samsung NX 16-50mm F3.5-5.6 Power Zoom ED OIS', #5
+    20 => 'Samsung NX 50-150mm F2.8 S ED OIS', #PH
+    21 => 'Samsung NX 300mm F2.8 ED OIS', #IB
+);
 
 # range of values for Formats used in encrypted information
@@ -31,5 +64,5 @@
 
 # Samsung "STMN" maker notes (ref PH)
-%Image::ExifTool::Samsung::Type1 = (
+%Image::ExifTool::Samsung::Main = (
     PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
     WRITE_PROC => \&WriteSTMN,
@@ -39,4 +72,5 @@
     FIRST_ENTRY => 0,
     IS_OFFSET => [ 2 ],   # tag 2 is 'IsOffset'
+    IS_SUBDIR => [ 11 ],
     GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
     NOTES => q{
@@ -54,4 +88,5 @@
         IsOffset => 3,
         Protected => 2,
+        WriteGroup => 'MakerNotes',
     },
     3 => {
@@ -60,5 +95,31 @@
         DataTag => 'PreviewImage',
         Protected => 2,
-    },
+        WriteGroup => 'MakerNotes',
+    },
+    11 => {
+        Name => 'SamsungIFD',
+        # Note: this is not always an IFD.  In many models the string
+        # "Park Byeongchan" is found at this location
+        Condition => '$$valPt =~ /^[^\0]\0\0\0/',
+        Format => 'undef[$size - 44]',
+        SubDirectory => { TagTable => 'Image::ExifTool::Samsung::IFD' },
+    },
+);
+
+%Image::ExifTool::Samsung::IFD = (
+    PROCESS_PROC => \&ProcessSamsungIFD,
+    NOTES => q{
+        This is a standard-format IFD found in the maker notes of some Samsung
+        models, except that the entry count is a 4-byte integer and the offsets are
+        relative to the end of the IFD.  Currently, no tags in this IFD are known,
+        so the L<Unknown|../ExifTool.html#Unknown> (-u) or L<Verbose|../ExifTool.html#Verbose> (-v) option must be used to see this
+        information.
+    },
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+    # 0x0001 - undef[4000|4100]: starts with "MN_PRV" (or all zeros)
+    # 0x0002 - undef[7000]     : starts with "Kim Miae"
+    # 0x0003 - undef[5000]     : starts with "Lee BK"
+    # 0x0004 - undef[500|2000] : starts with "IPCD"   (or all zeros)
+    # 0x0006 - undef[100|200]  : starts with "MN_ADS" (or all zeros)
 );
 
@@ -75,23 +136,156 @@
         Count => 4,
     },
+    0x0002 => {
+        Name => 'DeviceType',
+        Groups => { 2 => 'Camera' },
+        Writable => 'int32u',
+        PrintHex => 1,
+        PrintConv => {
+            0x1000 => 'Compact Digital Camera',
+            0x2000 => 'High-end NX Camera',
+            0x3000 => 'HXM Video Camera',
+            0x12000 => 'Cell Phone',
+            0x300000 => 'SMX Video Camera',
+        },
+    },
+    0x0003 => {
+        Name => 'SamsungModelID',
+        Groups => { 2 => 'Camera' },
+        Writable => 'int32u',
+        PrintHex => 1,
+        PrintConv => {
+            0x100101c => 'NX10',
+            0x1001226 => 'HMX-S10BP',
+            0x1001226 => 'HMX-S15BP',
+            0x1001233 => 'HMX-Q10',
+            0x1001234 => 'HMX-H300',
+            0x1001234 => 'HMX-H304',
+            0x100130c => 'NX100',
+            0x1001327 => 'NX11',
+            0x170104b => 'ES65, ES67 / VLUU ES65, ES67 / SL50',
+            0x170104e => 'ES70, ES71 / VLUU ES70, ES71 / SL600',
+            0x1701052 => 'ES73 / VLUU ES73 / SL605',
+            0x1701055 => 'ES25, ES27 / VLUU ES25, ES27 / SL45',
+            0x1701300 => 'ES28 / VLUU ES28',
+            0x1701303 => 'ES74,ES75,ES78 / VLUU ES75,ES78',
+            0x2001046 => 'PL150 / VLUU PL150 / TL210 / PL151',
+            0x2001048 => 'PL100 / TL205 / VLUU PL100 / PL101',
+            0x2001311 => 'PL120,PL121 / VLUU PL120,PL121',
+            0x2001315 => 'PL170,PL171 / VLUUPL170,PL171',
+            0x200131e => 'PL210, PL211 / VLUU PL210, PL211',
+            0x2701317 => 'PL20,PL21 / VLUU PL20,PL21',
+            0x2a0001b => 'WP10 / VLUU WP10 / AQ100',
+            0x3000000 => 'Various Models (0x3000000)',
+           #0x3000000 => 'DV150F / DV151F / DV155F',
+           #0x3000000 => 'NX mini',
+           #0x3000000 => 'NX3000',
+           #0x3000000 => 'NX3300',
+           #0x3000000 => 'ST150F / ST151F / ST152F',
+           #0x3000000 => 'WB200F / WB201F / WB202F',
+           #0x3000000 => 'WB250F / WB251F / WB252F',
+           #0x3000000 => 'WB30F / WB31F / WB32F',
+           #0x3000000 => 'WB350F / WB351F / WB352F',
+           #0x3000000 => 'WB800F',
+            0x3a00018 => 'Various Models (0x3a00018)',
+           #0x3a00018 => 'ES30 / VLUU ES30',
+           #0x3a00018 => 'ES80 / ES81',
+           #0x3a00018 => 'ES9 / ES8',
+           #0x3a00018 => 'PL200 / VLUU PL200',
+           #0x3a00018 => 'PL80 / VLUU PL80 / SL630 / PL81',
+           #0x3a00018 => 'PL90 / VLUU PL90',
+           #0x3a00018 => 'WB1100F / WB1101F / WB1102F',
+           #0x3a00018 => 'WB2200F',
+            0x400101f => 'ST1000 / ST1100 / VLUU ST1000 / CL65',
+            0x4001022 => 'ST550 / VLUU ST550 / TL225',
+            0x4001025 => 'Various Models (0x4001025)',
+           #0x4001025 => 'DV300 / DV300F / DV305F',
+           #0x4001025 => 'ST500 / VLUU ST500 / TL220',
+           #0x4001025 => 'ST200 / ST200F / ST201 / ST201F / ST205F',
+            0x400103e => 'VLUU ST5500, ST5500, CL80',
+            0x4001041 => 'VLUU ST5000, ST5000, TL240',
+            0x4001043 => 'ST70 / VLUU ST70 / ST71',
+            0x400130a => 'Various Models (0x400130a)',
+           #0x400130a => 'VLUU ST100, ST100',
+           #0x400130a => 'VLUU ST600, ST600',
+           #0x400130a => 'VLUU ST80, ST80',
+            0x400130e => 'ST90,ST91 / VLUU ST90,ST91',
+            0x4001313 => 'VLUU ST95, ST95',
+            0x4a00015 => 'VLUU ST60',
+            0x4a0135b => 'ST30, ST65 / VLUU ST65 / ST67',
+            0x5000000 => 'Various Models (0x5000000)',
+           #0x5000000 => 'EX2F',
+           #0x5000000 => 'NX1000',
+           #0x5000000 => 'NX20',
+           #0x5000000 => 'NX200',
+           #0x5000000 => 'NX210',
+           #0x5000000 => 'ST96',
+           #0x5000000 => 'WB750',
+           #0x5000000 => 'ST700',
+            0x5001038 => 'Various Models (0x5001038)',
+           #0x5001038 => 'EK-GN120',
+           #0x5001038 => 'HMX-E10',
+           #0x5001038 => 'NX1',
+           #0x5001038 => 'NX2000',
+           #0x5001038 => 'NX30',
+           #0x5001038 => 'NX300',
+           #0x5001038 => 'NX500',
+           #0x5001038 => 'SM-C200',
+           #0x5001038 => 'WB2000',
+            0x500103a => 'WB650 / VLUU WB650 / WB660',
+            0x500103c => 'WB600 / VLUU WB600 / WB610',
+            0x500133e => 'WB150 / WB150F / WB152 / WB152F / WB151',
+            0x5a0000f => 'WB5000 / HZ25W',
+            0x5a0001e => 'WB5500 / VLUU WB5500 / HZ50W',
+            0x6001036 => 'EX1',
+            0x700131c => 'VLUU SH100, SH100',
+            0x27127002 => 'SMX-C20N',
+        },
+    },
+    # 0x0004 - undef[x] (SamsungContentsID?)
+    # 0x000a - int32u (ContinuousShotMode?)
+    # 0x000b - int16u (BestPhotoMode?)
+    # 0x000c - int32u ? values: 0,1
+    # 0x000e - int32u[2] (SoundMultiPicture?)
+    # 0x0010 - rational64u ? values: undef,inf
+    0x0011 => { #6
+        Name => 'OrientationInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Samsung::OrientationInfo' },
+    },
+    0x0020 => [{ #forum7685
+        Name => 'SmartAlbumColor',
+        Condition => '$$valPt =~ /^\0{4}/',
+        Writable => 'int16u',
+        Count => 2,
+        PrintConv => {
+            '0 0' => 'n/a',
+        },
+    },{
+        Name => 'SmartAlbumColor',
+        Writable => 'int16u',
+        Count => 2,
+        PrintConv => [{
+            0 => 'Red',
+            1 => 'Yellow',
+            2 => 'Green',
+            3 => 'Blue',
+            4 => 'Magenta',
+            5 => 'Black',
+            6 => 'White',
+            7 => 'Various',
+        }],
+    }],
     0x0021 => { #1
         Name => 'PictureWizard',
         Writable => 'int16u',
-        Count => 5,
-        PrintConv => q{
-            my @a = split ' ', $val;
-            return $val unless @a == 5;
-            sprintf("Mode: %d, Col: %d, Sat: %d, Sha: %d, Con: %d",
-                    $a[0], $a[1], $a[2]-4, $a[3]-4, $a[4]-4);
-        },
-        PrintConvInv => q{
-            my @a = ($val =~ /[+-]?\d+/g);
-            return $val unless @a >= 5;
-            sprintf("%d %d %d %d %d", $a[0], $a[1], $a[2]+4, $a[3]+4, $a[4]+4);
-        },
-    },
-    # 0x0023 - string: "0123456789" (PH)
+        SubDirectory => { TagTable => 'Image::ExifTool::Samsung::PictureWizard' },
+    },
+    # 0x0022 - int32u (CaptureMode?) (Gamma? eg. 65538 = 1.2, ref forum7720)
+    # 0x0023 - string: "0123456789" (PH) (placeholder for SerialNumber?)
+    # 0x0025 - int32u (ImageCount?)
+    # 0x002a - undef[4] (SNSDirectShare?)
+    # 0x002f - string (GPSInfo01?)
     0x0030 => { #1 (NX100 with GPS)
         Name => 'LocalLocationName',
+        Groups => { 2 => 'Location' },
         Writable => 'string',
         Format => 'undef',
@@ -103,7 +297,21 @@
     0x0031 => { #1 (NX100 with GPS)
         Name => 'LocationName',
+        Groups => { 2 => 'Location' },
         Writable => 'string',
     },
-    0x0035 => {
+    # 0x0032 - string (GPSInfo03)
+    # 0x0033 - string (GPSInfo04)
+    # 0x0034 - string (GPSInfo05)
+    0x0035 => [{
+        Name => 'PreviewIFD',
+        Condition => '$$self{TIFF_TYPE} eq "SRW" and $$self{Model} ne "EK-GN120"', # (not an IFD in JPEG images)
+        Groups => { 1 => 'PreviewIFD' },
+        Flags => 'SubIFD',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Nikon::PreviewIFD',
+            ByteOrder => 'Unknown',
+            Start => '$val',
+        },
+    },{
         Name => 'PreviewIFD',
         Condition => '$$self{TIFF_TYPE} eq "SRW"', # (not an IFD in JPEG images)
@@ -113,5 +321,26 @@
             TagTable => 'Image::ExifTool::Nikon::PreviewIFD',
             ByteOrder => 'Unknown',
-            Start => '$val',
+            Start => '$val - 36',
+        },
+    }],
+    # 0x003a - int16u[2] (SmartLensInfo?)
+    # 0x003b - int16u[2] (PhotoStyleSelectInfo?)
+    # 0x003c - int16u (SmartRange?)
+    # 0x003d - int16u[5] (SmartCropInfo?)
+    # 0x003e - int32u (DualCapture?)
+    # 0x003f - int16u[2] (SGIFInfo?)
+    0x0040 => { #forum7432
+        Name => 'RawDataByteOrder',
+        PrintConv => {
+            0 => 'Little-endian (Intel, II)',
+            1 => 'Big-endian (Motorola, MM)', #(NC)
+        },
+    },
+    0x0041 => { #forum7684
+        Name => 'WhiteBalanceSetup',
+        Writable => 'int32u',
+        PrintConv => {
+            0 => 'Auto',
+            1 => 'Manual',
         },
     },
@@ -121,14 +350,49 @@
         Writable => 'rational64s',
         # (DPreview samples all 0.2 C --> pre-production model)
-        PrintConv => '"$val C"',
+        PrintConv => '$val =~ /\d/ ? "$val C" : $val',
         PrintConvInv => '$val=~s/ ?C//; $val',
     },
-    # 0x00a0 - undef[8192]: white balance information (ref 1):
+    # 0x0045 => { Name => 'RawCompressionMode', Writable => 'int32u' }, # (related to ExposureMode, not raw compresison? ref forum7432)
+    # 0x004a - int32u[7] (ImageVerification?)
+    # 0x004b - int32u[2] (RewindInfo?)
+    # 0x0050 - int32u (ColorSpace? - inconsistent) values: 1 (related to compression mode, ref forum7432)
+    0x0050 => { #forum7432
+        Name => 'RawDataCFAPattern',
+        PrintConv => {
+            0 => 'Unchanged',
+            1 => 'Swap',
+            65535 => 'Roll',
+        },
+    },
+    # 0x0054 - int16u[2] (WeatherInfo?)
+    # 0x0060 - undef (AEInfo?)
+    # 0x0080 - undef (AFInfo?)
+    # 0x00a0 - undef[8192] (AWBInfo1): white balance information (ref 1):
     #   At byte 5788, the WBAdjust: "Adjust\0\X\0\Y\0\Z\xee\xea\xce\xab", where
     #   Y = BA adjust (0=Blue7, 7=0, 14=Amber7), Z = MG (0=Magenta7, 7=0, 14=Green7)
+    # 0x00a1 - undef (AWBInfo2?)
+    # 0x00c0 - undef (IPCInfo?)
+    # 0x00c7 - undef (SmartFunctionInfo?)
+    # 0x00e0 - int16u (SceneResult?)
+    # 0x00e1 - int16u[8] (SADebugInfo01?)
+    # 0x00e1 - int16u[x] (SADebugInfo02?)
+    0x0100 => {
+        Name => 'FaceDetect',
+        Writable => 'int16u',
+        PrintConv => { 0 => 'Off', 1 => 'On' }, #(NC)
+    },
+    # 0x0101 - int16u[6] (FaceDetectInfo?)
+    # 0x0102 - int16u[x] (FaceDetectInfo?)
+    0x0120 => {
+        Name => 'FaceRecognition',
+        Writable => 'int32u',
+        PrintConv => { 0 => 'Off', 1 => 'On' }, #(NC)
+    },
+    0x0123 => { Name => 'FaceName', Writable => 'string' },
+    # 0x140 - undef (LensInfo?)
 #
 # the following tags found only in SRW images
 #
-    # 0xa000 - rational64u: 1 or 1.1 (ref PH)
+    # 0xa000 - rational64u: 1 or 1.1 (ref PH) (MakerNoteVersion?)
     0xa001 => { #1
         Name => 'FirmwareName',
@@ -136,19 +400,16 @@
         Writable => 'string',
     },
-    # 0xa002 - string[30]: '0' or 'DY049P000000' (ref PH)
+    0xa002 => { #PH/IB
+        Name => 'SerialNumber',
+        Condition => '$$valPt =~ /^\w{5}/', # should be at least 5 characters long
+        Groups => { 2 => 'Camera' },
+        Writable => 'string',
+    },
     0xa003 => { #1 (SRW images only)
         Name => 'LensType',
         Groups => { 2 => 'Camera' },
         Writable => 'int16u',
-        PrintConv => {
-            0 => 'Built-in', #PH (EX1, WB2000)
-            1 => 'Samsung 30mm F2 Pancake',
-            2 => 'Samsung Zoom 18-55mm F3.5-5.6 OIS',
-            3 => 'Samsung Zoom 50-200mm F4-5.6 ED OIS',
-            # what about the non-OIS version of the 18-55,
-            # which was supposed to be available before the 20-50?
-            4 => 'Samsung 20-50mm F3.5-5.6 Compact Zoom', #PH
-            5 => 'Samsung 20mm F2.8 Pancake', #PH (guess)
-        },
+        Count => -1,
+        PrintConv => [ \%samsungLensTypes ],
     },
     0xa004 => { #1
@@ -157,5 +418,9 @@
         Writable => 'string',
     },
-    # 0xa005 - string[30]: constant for a given lens? Not the printed serial number (ref 1)
+    0xa005 => {
+        Name => 'InternalLensSerialNumber', # Not the printed serial number (ref 1)
+        Groups => { 2 => 'Camera' },
+        Writable => 'string',
+    },
     0xa010 => { #1
         Name => 'SensorAreas',
@@ -190,8 +455,9 @@
         Writable => 'rational64u',
         PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
-        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+        PrintConvInv => '$val',
     },
     0xa019 => { #1
         Name => 'FNumber',
+        Priority => 0,
         Writable => 'rational64u',
         PrintConv => 'sprintf("%.1f",$val)',
@@ -201,4 +467,5 @@
         Name => 'FocalLengthIn35mmFormat',
         Groups => { 2 => 'Camera' },
+        Priority => 0,
         Format => 'int32u',
         ValueConv => '$val / 10',
@@ -207,4 +474,6 @@
         PrintConvInv => '$val=~s/\s*mm$//;$val',
     },
+    # 0xa01b - int32u (ImageCount?)
+    # 0xa01b - int16u (LDCLens?)
     0xa020 => { #1
         Name => 'EncryptionKey',
@@ -246,11 +515,14 @@
         RawConvInv => 'Image::ExifTool::Samsung::Crypt($self,$val,$tagInfo,1)',
     },
-    #this doesn't seem correct
-    #0xa025 => { #PH/1
-    #    Name => 'ColorTemperatureAuto',
-    #    Writable => 'int32u',
-    #    RawConv    => 'Image::ExifTool::Samsung::Crypt($self,$val,$tagInfo,6)',
-    #    RawConvInv => 'Image::ExifTool::Samsung::Crypt($self,$val,$tagInfo,-6)',
-    #},
+    0xa025 => { # (PostAEGain?)
+        Name => 'DigitalGain', #IB
+        Writable => 'int32u',
+        RawConv    => 'Image::ExifTool::Samsung::Crypt($self,$val,$tagInfo,6)',
+        RawConvInv => 'Image::ExifTool::Samsung::Crypt($self,$val,$tagInfo,-6)',
+    },
+    0xa025 => { #IB
+        Name => 'HighlightLinearityLimit',
+        Writable => 'int32u',
+    },
     0xa028 => { #2/PH
         Name => 'WB_RGGBLevelsBlack',
@@ -282,7 +554,5 @@
     },
     0xa033 => { #1
-        Name => 'Samsung_Type2_0xa033',
-        Unknown => 1,
-        Hidden => 1,
+        Name => 'CbCrMatrixDefault',
         Writable => 'int32s',
         Count => 4,
@@ -291,7 +561,5 @@
     },
     0xa034 => { #1
-        Name => 'Samsung_Type2_0xa034',
-        Unknown => 1,
-        Hidden => 1,
+        Name => 'CbCrMatrix',
         Writable => 'int32s',
         Count => 4,
@@ -300,7 +568,5 @@
     },
     0xa035 => { #1
-        Name => 'Samsung_Type2_0xa035',
-        Unknown => 1,
-        Hidden => 1,
+        Name => 'CbCrGainDefault',
         Writable => 'int32u',
         Count => 2,
@@ -309,7 +575,5 @@
     },
     0xa036 => { #1
-        Name => 'Samsung_Type2_0xa036',
-        Unknown => 1,
-        Hidden => 1,
+        Name => 'CbCrGain',
         Writable => 'int32u',
         Count => 2,
@@ -318,5 +582,5 @@
     },
     0xa040 => { #1
-        Name => 'ToneCurve1',
+        Name => 'ToneCurveSRGBDefault',
         Writable =>  'int32u',
         Count => 23,
@@ -329,5 +593,5 @@
     },
     0xa041 => { #1
-        Name => 'ToneCurve2',
+        Name => 'ToneCurveAdobeRGBDefault',
         Writable =>  'int32u',
         Count => 23,
@@ -336,5 +600,5 @@
     },
     0xa042 => { #1
-        Name => 'ToneCurve3',
+        Name => 'ToneCurveSRGB',
         Writable =>  'int32u',
         Count => 23,
@@ -343,5 +607,5 @@
     },
     0xa043 => { #1
-        Name => 'ToneCurve4',
+        Name => 'ToneCurveAdobeRGB',
         Writable =>  'int32u',
         Count => 23,
@@ -350,7 +614,6 @@
     },
     0xa048 => { #1
-        Name => 'Samsung_Type2_0xa048',
+        Name => 'RawData',
         Unknown => 1,
-        Hidden => 1,
         Writable => 'int32s',
         Count => 12,
@@ -358,8 +621,7 @@
         RawConvInv => 'Image::ExifTool::Samsung::Crypt($self,$val,$tagInfo,"-0")',
     },
-    0xa050 => { #1 (vignette curve?)
-        Name => 'Samsung_Type2_0xa050',
+    0xa050 => { #1
+        Name => 'Distortion',
         Unknown => 1,
-        Hidden => 1,
         Writable => 'int32s',
         Count => 8,
@@ -368,7 +630,6 @@
     },
     0xa051 => { #1
-        Name => 'Samsung_Type2_0xa051',
+        Name => 'ChromaticAberration',
         Unknown => 1,
-        Hidden => 1,
         Writable => 'int16u',
         Count => 22,
@@ -376,8 +637,7 @@
         RawConvInv => 'Image::ExifTool::Samsung::Crypt($self,$val,$tagInfo,0,7,3)',
     },
-    0xa052 => { #1 (vignette curve?)
-        Name => 'Samsung_Type2_0xa052',
+    0xa052 => { #1
+        Name => 'Vignetting',
         Unknown => 1,
-        Hidden => 1,
         Writable => 'int16u',
         Count => 15,
@@ -386,7 +646,6 @@
     },
     0xa053 => { #1
-        Name => 'Samsung_Type2_0xa053',
+        Name => 'VignettingCorrection',
         Unknown => 1,
-        Hidden => 1,
         Writable => 'int16u',
         Count => 15,
@@ -395,7 +654,6 @@
     },
     0xa054 => { #1
-        Name => 'Samsung_Type2_0xa054',
+        Name => 'VignettingSetting',
         Unknown => 1,
-        Hidden => 1,
         Writable => 'int16u',
         Count => 15,
@@ -404,5 +662,5 @@
     },
     0xa055 => { #1
-        Name => 'Samsung_Type2_0xa055',
+        Name => 'Samsung_Type2_0xa055', # (DistortionCamera1st?)
         Unknown => 1,
         Hidden => 1,
@@ -413,5 +671,5 @@
     },
     0xa056 => { #1
-        Name => 'Samsung_Type2_0xa056',
+        Name => 'Samsung_Type2_0xa056', # (DistortionCamera2nd?)
         Unknown => 1,
         Hidden => 1,
@@ -422,5 +680,5 @@
     },
     0xa057 => { #1
-        Name => 'Samsung_Type2_0xa057',
+        Name => 'Samsung_Type2_0xa057', # (DistortionCameraSetting?)
         Unknown => 1,
         Hidden => 1,
@@ -429,4 +687,77 @@
         RawConv    => 'Image::ExifTool::Samsung::Crypt($self,$val,$tagInfo,2)',
         RawConvInv => 'Image::ExifTool::Samsung::Crypt($self,$val,$tagInfo,-2)',
+    },
+    # 0xa060 - rational64u (CISTemperature?)
+    # 0xa061 - int16u (Compression?)
+);
+
+# orientation information (ref 6)
+%Image::ExifTool::Samsung::OrientationInfo = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    WRITABLE => 1,
+    FORMAT => 'rational64s',
+    FIRST_ENTRY => 0,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Camera orientation information written by the Gear 360 (SM-C200).',
+    0 => {
+        Name => 'YawAngle', #(NC)
+        Unknown => 1,
+        Notes => 'always zero',
+    },
+    1 => {
+        Name => 'PitchAngle',
+        Notes => 'upward tilt of rear camera in degrees',
+    },
+    2 => {
+        Name => 'RollAngle',
+        Notes => 'clockwise rotation of rear camera in degrees',
+    },
+);
+
+# Picture Wizard information (ref 1)
+%Image::ExifTool::Samsung::PictureWizard = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    WRITABLE => 1,
+    FORMAT => 'int16u',
+    FIRST_ENTRY => 0,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+    0 => {
+        Name => 'PictureWizardMode',
+        PrintConvColumns => 3,
+        PrintConv => { #3
+             0 => 'Standard',
+             1 => 'Vivid',
+             2 => 'Portrait',
+             3 => 'Landscape',
+             4 => 'Forest',
+             5 => 'Retro',
+             6 => 'Cool',
+             7 => 'Calm',
+             8 => 'Classic',
+             9 => 'Custom1',
+            10 => 'Custom2',
+            11 => 'Custom3',
+           255 => 'n/a', #PH
+        },
+    },
+    1 => 'PictureWizardColor',
+    2 => {
+        Name => 'PictureWizardSaturation',
+        ValueConv => '$val - 4',
+        ValueConvInv => '$val + 4',
+    },
+    3 => {
+        Name => 'PictureWizardSharpness',
+        ValueConv => '$val - 4',
+        ValueConvInv => '$val + 4',
+    },
+    4 => {
+        Name => 'PictureWizardContrast',
+        ValueConv => '$val - 4',
+        ValueConvInv => '$val + 4',
     },
 );
@@ -465,5 +796,5 @@
         Format => 'string[16]',
     },
-    0x2e => { # (NC)
+    0x2e => { #(NC)
         Name => 'ExposureTime',
         Format => 'int32u',
@@ -476,5 +807,5 @@
         PrintConv => 'sprintf("%.1f",$val)',
     },
-    0x3a => { # (NC)
+    0x3a => { #(NC)
         Name => 'ExposureCompensation',
         Format => 'rational64s',
@@ -488,5 +819,5 @@
         Name => 'Software',
         Format => 'string[32]',
-        # (these tags are not at a constant offset for Sanyo videos,
+        # (these tags are not at a constant offset for Olympus/Sanyo videos,
         #  so just to be safe use this to validate subsequent tags)
         RawConv => q{
